#This is very hacky due to different versions of x264

%define date		20220222
%define major		164
%define libname		%mklibname %{name}_ %{major}
%define develname	%mklibname %{name} -d

Name: 		x264
Version: 	1.%{major}
Release: 	%mkrel 4
Summary: 	H264/AVC encoder
License: 	GPLv2+
Group: 		Video
URL: 		https://www.videolan.org/developers/x264.html
Source0: %{name}-master.tar.xz

Source1: libx264.so.138
Source2: libx264.so.148
Source3: libx264.so.155

Patch1:		x264-use-upstream-opt-level.patch

BuildRequires:	ffmpeg-devel
BuildRequires:	git-core
BuildRequires:	pkgconfig(gpac)
BuildRequires:	pkgconfig(x11)
BuildRequires:	nasm
BuildRequires:	bash-completion

%description
x264 is a free library for encoding H264/AVC video streams. The code
is written by Laurent Aimar, Eric Petit(OS X), Min Chen (vfw/nasm),
Justin Clay(vfw), Måns Rullgård and Loren Merritt from scratch. It is
released under the terms of the GPL license.

This package is in tainted repository as the video encoder may be covered
by software patents.

#------------------------------------------------------------------------

%package -n	%{libname}
Summary:	Shared library of x264
Group:		System/Libraries

%description -n %{libname}
x264 dynamic libraries.

#------------------------------------------------------------------------
%package -n	lib64x264_138
Summary:	Shared library of x264
Group:		System/Libraries

%description -n 	lib64x264_138
x264 dynamic libraries.

#------------------------------------------------------------------------
%package -n	lib64x264_148
Summary:	Shared library of x264
Group:		System/Libraries

%description -n 	lib64x264_148
x264 dynamic libraries.

#------------------------------------------------------------------------
%package -n	lib64x264_155
Summary:	Shared library of x264
Group:		System/Libraries

%description -n 	lib64x264_155
x264 dynamic libraries.

%package -n	%{develname}
Summary:	H264/AVC encoding library headers
Group:		Development/Libraries
Requires:	%{libname} = %{version}
Obsoletes: lib%{name}-devel
Provides:	lib%{name}-devel = %{version}-%{release}
Obsoletes: %{name}-devel
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes: x264-static-devel

%description -n %{develname}
x264 is a free library for encoding H264/AVC video streams. The code
is written by Laurent Aimar, Eric Petit(OS X), Min Chen (vfw/nasm),
Justin Clay(vfw), Måns Rullgård and Loren Merritt from scratch. It is
released under the terms of the GPL license.

#------------------------------------------------------------------------

%prep
%setup -q -n %{name}-master
%autopatch -p1

perl -pi -e 's|usr/local|usr||g' configure

%build
./configure \
		--prefix=%{_prefix} \
		--libdir=%{_libdir} \
		--extra-cflags="%{optflags}" \
		--extra-ldflags="%{ldflags}" \
		--enable-shared \
		--enable-lto \
		--system-libx264 \
		--enable-pic

%make_build

%install
rm -rf %buildroot
%make_install

# we don't want these
find %{buildroot} -name "*.la" -delete

install -m 0755 %SOURCE1 %buildroot/%{_libdir}
install -m 0755 %SOURCE2 %buildroot/%{_libdir}
install -m 0755 %SOURCE3 %buildroot/%{_libdir}

%files
%{_bindir}/%{name}
%{_datadir}/bash-completion/completions/%{name}

%files -n %{libname}
%{_libdir}/lib%{name}.so.%{major}*

%files -n lib64x264_138
%{_libdir}/libx264.so.138

%files -n lib64x264_148
%{_libdir}/libx264.so.148

%files -n lib64x264_155
%{_libdir}/libx264.so.155

%files -n %{develname}
%{_libdir}/lib%{name}.so
%{_includedir}/%{name}*.h
%{_libdir}/pkgconfig/%{name}.pc



%changelog
* Tue Oct 10 2023 tex - 1.164-4pclos2023
- rebuild against updates

* Tue Mar 28 2023 tex - 1.164-3pclos2023
- rebuild against updates

* Thu Mar 09 2023 onkelho <oh.quait at gmail.com> - 1.164-2pclos2023
- rebuild against updates ffmpeg

* Tue Jan 31 2023 tex - 1.164-1pclos2023
- new version
- lets hope this works
